package com.jiuqi.grid;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.jiuqi.grid.PropList;

final class Key {
  private byte[] property;
  
  private int hash;
  
  public Key() {}
  
  public Key(byte[] property) {
    setProperty(property);
  }
  
  public Key setProperty(byte[] property) {
    this.property = property;
    if (property == null) {
      this.hash = 0;
    } else {
      this.hash = 1;
      for (int i = 0; i < property.length; i++)
        this.hash = 31 * this.hash + property[i]; 
    } 
    return this;
  }
  
  public int hashCode() {
    return this.hash;
  }
  
  public boolean equals(Object obj) {
    if (hashCode() != obj.hashCode() || !(obj instanceof Key))
      return false; 
    Key another = (Key)obj;
    if (this.property == null)
      return (another.property == null); 
    for (int i = 0; i < this.property.length; i++) {
      if (this.property[i] != another.property[i])
        return false; 
    } 
    return true;
  }
  
  public String toString() {
    StringBuffer s = new StringBuffer();
    s.append(this.property).append('(').append(this.hash).append(')');
    return s.toString();
  }
}
